/* fbbtext.c 
   by G0LGS July 2001 */

//  PG Prgoram called from FBB:
//  call-ssid level_nbr user_flags user_record_nbr received_data

#include "config.h"

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <unistd.h>

// From ttutils
int get_config (void);
void store_user (char *p);
void translate_user (char *from, char *to);
int show_page(FILE *f, char *page_no);
void show_prompt(FILE *fout);
void show_vers (void);
int  ReadInit( void );
void Log(char *logtext);

extern int page_nbr , level_nbr ;

// variables that the config file can overwrite
extern char first_page[] , help_page[] ;
extern char no_page[], index_page[];
extern int max, linemax;
extern char prompt [] ;
extern char data_path[];

// user info
extern char u_name[13];
extern char u_city[31];
extern char u_home[41];
extern char u_qra[7];
extern char u_zip[9];

// Values for ttutils
char from_call[12];
char from_bbs[64] = "FBB";
char app_name[5] = "PGTT";

// Local
void Read_Inf(int inf_rec);

#define __a2__ __attribute__ ((packed, aligned(2)))

typedef struct typindic
{
        char call[7];
        char num;
}
indicat;
 
typedef struct
{
        indicat indic;                  /* 8  Callsign */
        indicat relai[8];               /* 64 Digis path */
        long    lastmes __a2__;         /* 4  Last L number */
        long    nbcon   __a2__;         /* 4  Number of connexions */
        long    hcon    __a2__;         /* 4  Last connexion date */
        long    lastyap __a2__;         /* 4  Last YN date */
        unsigned short  flags;          /* 2  Flags */
        unsigned short  on_base;        /* 2  ON Base number */
        unsigned char   nbl;            /* 1  Lines paging */
        unsigned char   lang;           /* 1  Language */
        long    newbanner __a2__;       /* 4  Last Banner date */
        unsigned short  download  ;     /* 2  download size (KB) = 100 */
        char    free[20];               /* 20 Reserved */
        char    theme;                  /* 1  Current topic */
        char    nom[18];                /* 18 1st Name */
        char    prenom[13];             /* 13 Christian name */
        char    adres[61];              /* 61 Address */
        char    ville[31];              /* 31 City */
        char    teld[13];               /* 13 home phone */
        char    telp[13];               /* 13 modem phone */
        char    home[41];               /* 41 home BBS */
        char    qra[7];                 /* 7  Qth Locator */
        char    priv[13];               /* 13 PRIV directory */
        char    filtre[7];              /* 7  LC choice filter */
        char    pass[13];               /* 13 Password */
        char    zip[9];                 /* 9  Zipcode */
                                        /* Total : 360 bytes */
}
info;

// ======================================================================

int main(int argc, char **argv)
{
	char temp [100], temp2[50];
	char *p, arg [80] ="";
	int inf_rec;
	char tmp[80];

	if (argc < 5){
		printf("Error - invalid parameters\n");
		// return user to BBS
		return (0) ;
	}

        // Read FBB Config
        if( ReadInit() != 0 ){
                fprintf( stderr, "ERROR: Unable to process FBB Config\n" );
                return (2);
        }

	get_config();
    
	level_nbr = atoi(argv[2]);

	inf_rec = atoi(argv[4]);

	Read_Inf(inf_rec);

	strcpy( from_call, argv[1]); 
	if ( (p = strchr( from_call,'-')) !=NULL) *p = 0;

	if( argc > 5 ){
		// Ignore CR/LF
		sscanf( argv[5], "%[^\r\n]", arg ); 
	}

	if( level_nbr == 0 ) {
		sprintf( tmp, "%s Opened Session", from_call );
		Log( tmp );
	}

	if( strcasecmp( arg, "B" ) == 0 ) {
		sprintf( tmp, "%s Logged Off after %d uses", from_call, level_nbr );
		Log( tmp );
		return (2);	// logoff

	} else if( strcasecmp( arg, "F" ) == 0 ) {
		sprintf( tmp, "%s Finished Session after %d uses", from_call, level_nbr );
		Log( tmp );
		return (0);	//return to FBB

	} else if( strcasecmp( arg, "I" ) == 0 ) {
		show_vers();
		show_prompt( stdout );
		return (1);	//go again & increment level nbr
	}

	if( strcasecmp( arg, "?" ) == 0 ) {
		show_page( stdout, help_page );
		show_prompt( stdout );
		return (1);	//go again & increment level nbr

	} else {

		page_nbr = atoi(arg); 

		if ( page_nbr > 0 ) {
			sprintf( temp, "%03i", page_nbr );
		} else {
			sprintf( temp, "%s ", arg );
		}

		translate_user( temp, temp2 );

		if( show_page( stdout, temp2 ) == 0 ) {

			show_prompt( stdout );
			return (1); 	//go again & increment level nbr

		} else if( level_nbr == 0 ) {
			show_page( stdout, first_page );
			show_prompt( stdout );
			return (1); //go again & increment level nbr
		}

		//fall through if show_page failed
	}

	// unrecognised command or invalid/missing page number
	// give some help.

	show_page( stdout, no_page );
	show_prompt( stdout );

	return (1); 	//go again
}        

void Read_Inf(int inf_rec)
{
	info userrec;
	char infsys[255];
	FILE *inf;

	sprintf( infsys, "%s/inf.sys", data_path );

	if( ( inf = fopen( infsys, "rb") ) != NULL ){

		fseek( inf, inf_rec * sizeof(info), SEEK_SET );

		if( fread( &userrec, sizeof(info), 1, inf ) == 1 ){

			strcpy( u_name, userrec.prenom );
			strcpy( u_city, userrec.ville );
			strcpy( u_home, userrec.home );
			strcpy( u_qra, userrec.qra );
			strcpy( u_zip, userrec.zip );
		}

		fclose( inf );
        }

}

