/* reqtt.c for XFBB 7.0x by G0LGS July 2001 */

// Message Server Called from FBB 
//	Input filename

#include "config.h"

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <unistd.h>

// From ttutils
int get_config (void);
int show_page(FILE *f, char *page_no);
void get_pages(void);
void show_line( FILE *fout, char *line, char *page_no );
void translate_user (char *from, char *to);
int ReadInit(void);
void Log(char *logtext);

// local
void Read_Header(void);
void Start_Msg(void);
void End_Msg(void);
void Do_Pages(void);
void pg_report(FILE *fmail, char *linebuffer);
void ln_report(FILE *fmail, char *linebuffer );

// variables that the config file can overwrite
extern int maxpages, linemax;
extern char mailin [] ;
extern char no_page[];
extern char bbs_call[];
extern char infofile[];

extern int lines;

// user info 
extern char u_name[13];
extern char u_city[31];
extern char u_home[41];
extern char u_qra[7];
extern char u_zip[9];

FILE *fmsg, *fmail;

// for ttutils
char from_call[12];
char from_bbs[64] = "PBBS";
char app_name[6] = "REQTT";

char buffer[255];
char subject[80];

// =========================================================================

int main(int argc, char **argv)
{
	char tmp[80];

	if (argc != 2){
		printf( "REQTT: Invalid Parameters\n" );
		return (2) ; 
	}

	// Read FBB Config
	if( ReadInit() != 0 ){
		fprintf( stderr, "ERROR: Unable to Process fbb.conf\n" );
		sprintf( tmp, "ERROR: Unable to Process fbb.conf" );
		Log( tmp );
		return (2);
	}

	if ( (fmsg=fopen(argv[1],"r") ) == NULL) {
		fprintf( stderr, "ERROR: Unable to open Input Message '%s'\n", argv[1] );
		sprintf( tmp, "ERROR: Unable to open Input Message '%s'", argv[1] );
		Log( tmp );
		return (2);
	}

	// Read our CONFIG
	get_config();
     
	Read_Header();

	if( (fmail = fopen( mailin, "a" )) == NULL ) {
		fprintf( stderr, "ERROR: Unable to append to %s\n", mailin );
		sprintf( tmp, "ERROR: Unable to append  to '%s'", mailin );
		Log( tmp );
		return(2);
	}


	Start_Msg();

	Do_Pages();
    
	End_Msg();

	fclose(fmail);
 
	unlink(argv[1]);

	return (0);
}

// =========================================================================

void Read_Header()
{
	int end = 0;
	int Date, Time;
	char Text[80];
	int msg_pos;

        /* Read the From line */
        fgets(buffer, sizeof(buffer), fmsg);
        sscanf(buffer, "%*s %*s %*s %s", from_call );
 
        /* Read the Subject */
        fgets(buffer, sizeof(buffer), fmsg);
        sscanf(buffer, "%[^\n]\n", subject);
 
	msg_pos = ftell( fmsg );

        /* Extract Original BBS from R: lines */
        end=0;
        while( ! end && ! feof(fmsg) && (fgets( buffer, sizeof(buffer), fmsg ) ) ){
 
                /* R: lines */
                if( sscanf( buffer,"R:%d/%d%*[^@]@:%s", &Date, &Time, from_bbs ) >= 1 ) {
			msg_pos = ftell( fmsg );
                        continue;
 
                /* Skip T: lines */
                }else if( sscanf( buffer,"T:%[^\n]\n", Text ) != 0 ) {
			msg_pos = ftell( fmsg );
                        continue;
 
                /* End of R: / T: lines */
                }else{
                        end =1;
                }
        }

	// Move pointer back to start of last line
	fseek( fmsg, msg_pos, SEEK_SET );
}

// =========================================================================

void Start_Msg(void)
{
        if( strlen(from_bbs) >= 6 ) {
                fprintf( fmail, "#\nSP %s @ %s < %s\n", from_call, from_bbs, bbs_call );
        }else{
                fprintf( fmail, "#\nSP %s < %s\n", from_call, bbs_call );
        }
 
        fprintf( fmail, "Re: %s\n", subject );	
}

// =========================================================================

void End_Msg(void)
{
	fprintf( fmail, "\n REQTT V" Version " by G0LGS\n");
	fprintf( fmail, "/EX\n" );
}

// =========================================================================

void Do_Pages(void)
{
	int pages_sent = 0;
	char page[10];

	while( !feof( fmsg ) && fgets(buffer, sizeof(buffer), fmsg ) ){

		// Ignore Blank line
		if( *buffer == '\0' ) {
			continue;
		}

		// Ignore FBB From: line
		if( strncmp( buffer, "From: ", 6 ) == 0 ) {
			continue;
		}

		// Ignore FBB To: line
		if( strncmp( buffer, "To  : ", 6 ) == 0 ) {
			continue;
		}

		// Ignore /ack
		if( strncasecmp( buffer, "/ack", 4 ) == 0 ) {
			continue;
		}

		// Ignore /ex
		if( strncasecmp( buffer, "/ex", 3 ) == 0 ) {
			continue;
		}

		// Finish at Start of Signature
		if( strncmp( buffer, "---", 3 ) == 0 ) {
			// skip rest of message
			fseek( fmsg, 0, SEEK_END );
			continue;
		}

		translate_user( buffer, page );

		if( pages_sent < maxpages ) {

			if( lines < linemax ) {

				if( strlen( page ) > 0 ) {

					if( show_page( fmail, page ) != 0 ) {
						show_page( fmail, no_page );
					} else {
						pages_sent++;
					}
				}

			} else {

				ln_report( fmail, page );

				// skip rest of message
				fseek( fmsg, 0, SEEK_END );
			}

		} else {

			pg_report( fmail, page );

			// skip rest of message
			fseek( fmsg, 0, SEEK_END );
		}

	} // while


	if( pages_sent == 0 ) {		// oops, nothing sent!

		fprintf( fmail, "\r\nNo pages Found\r\n" );
	}

	fclose(fmsg);

	if ( (fmsg=fopen( infofile, "r") ) != NULL) {

	        while( ! feof(fmsg) && fgets( buffer, sizeof(buffer), fmsg ) ) {
 
			show_line( fmail, buffer, 0 );

		}
		fclose(fmsg);
	}

}

// =========================================================================

void  pg_report(FILE *fmail, char *pg )
{
	fprintf( fmail, " ********** ERROR REPORT **********\n");
	fprintf( fmail, "\n\nYou requested: %s\n\n", pg );
	fprintf( fmail, "This exceeds the maximum of %i requests per message", maxpages );
	fprintf( fmail, " and has not been supplied\n\n");
	fprintf( fmail, " **********************************\n");
}
// =========================================================================

void  ln_report(FILE *fmail, char *pg )
{
	fprintf( fmail, " ********** ERROR REPORT **********\n");
	fprintf( fmail, "\n\nYou requested: %s\n\n", pg );
	fprintf( fmail, "This exceeds the maximum of %i lines per message", linemax );
	fprintf( fmail, " and has not been supplied\n\n");
	fprintf( fmail, " **********************************\n");
}

