/* ttupd.c for XFBB 7.xx by G0LGS July 2001 */

// called from FBB with parameters: - input file

#include "config.h"

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <unistd.h>
#include <unistd.h>

// From ttutils
int get_config(void);
void get_page(void);
void translate_user(char *from, char *to);
void show_line( FILE *fout, char *line, char *page_no );
int  user_allowed(void);
int ReadInit(void);
void Log(char *logtext);
 
extern int page_nbr , level_nbr ;
extern char bbs_call[];
extern char sys_call[];

// for ttutils
char from_call[12];
char from_bbs[64];
char app_name[10] = "TTUPD";

// variables that the config file can overwrite
extern int max, linemax;
extern char mailin [] ;
extern char no_page[];
extern char ttext_dir [];
extern char infofile[];

// local
void Read_Header(void);
void Start_Msg(void);
void End_Msg(void);
void Process_Mail(void);
int Do_update(char *page);
int Do_request(char *page);

FILE *fmsg, *fmail, *fpage;

char buffer[255];
char subject[80];

// ======================================================================

int main(int argc, char **argv)
{
	char tmp[80];

        if (argc != 2){
                printf( "TTUPD: Invalid Parameters\n" );
                return (2) ;
        }
 
        // Read FBB Config
        if( ReadInit() != 0 ){
                fprintf( stderr, "ERROR: Unable to process FBB Config\n" );		
                return (2);
        }
 
        // Read our CONFIG
        get_config();
 
        if ( (fmsg=fopen(argv[1],"r") ) == NULL) {
                fprintf( stderr, "ERROR: Unable to open Input Message '%s'\n", argv[1] );
		sprintf( tmp, "ERROR: Unable to open Input Message '%s'", argv[1] );
		Log( tmp );
                return (2);
        }
 
	// Read Message Header
        Read_Header();
 
        if( (fmail = fopen( mailin, "a" )) == NULL ) {
		fprintf( stderr, "ERROR: Unable to append to '%s'\n", mailin );
		sprintf( tmp, "ERROR: Unable to append to '%s'", mailin );
		Log( tmp );
		return(2);
	}
 
	// Deal with Messages from un-authorised users
	if( user_allowed() != 0 ) {

		// Message to User
        	Start_Msg();
	 
		fprintf( fmail, "Sorry, You are not authorised to use TTUPD server, if you think\n" );
		fprintf( fmail, "you should be please advise the Sysop (%s @ %s).\n", sys_call, bbs_call  );

	        End_Msg();

		// Message to Sysop
                fprintf( fmail, "#\nSP %s < %s\n", sys_call, bbs_call );
	        fprintf( fmail, "TTUPD Warning\n\n\n" );

	        if( strlen(from_bbs) >= 6 ) {
        	        fprintf( fmail, "Warning: An unauthorised user (%s @ %s) attempted to use the TTUPD server\n", from_call, from_bbs );
        	        sprintf( tmp, "Unauthorised user (%s @ %s)", from_call, from_bbs );
	        }else{
        	        fprintf( fmail, "Warning:  An unauthorised user (%s) attempted to use the TTUPD server\n", from_call );
        	        sprintf( tmp, "Unauthorised user (%s)", from_call );
	        }
 
	        End_Msg();
 
		Log( tmp );

	}else{

        	Start_Msg();
	 
	        Process_Mail();

	        End_Msg();
 
 	}

        fclose(fmail);
 
	unlink(argv[1]);
 
	return (0);
}        

// ======================================================================

void Read_Header()
{
        int end = 0;
        int Date, Time;
        char Text[80];
	int msg_pos;
 
        // Read the From line 
        fgets(buffer, sizeof(buffer), fmsg);
        sscanf(buffer, "%*s %*s %*s %s", from_call );
 
        // Read the Subject
        fgets(buffer, sizeof(buffer), fmsg);
        sscanf(buffer, "%[^\r\n]", subject);
 
	msg_pos = ftell( fmsg );

        // Extract Original BBS from R: lines
        end=0;
        while( ! end && ! feof(fmsg) && (fgets( buffer, sizeof(buffer), fmsg ) ) ){
 
                // R: lines 
                if( sscanf( buffer,"R:%d/%d%*[^@]@:%s", &Date, &Time, from_bbs ) >= 1 ) {
			msg_pos = ftell( fmsg );
                        continue;
 
                // Skip T: lines
                }else if( sscanf( buffer,"T:%[^\n]\n", Text ) != 0 ) {
			msg_pos = ftell( fmsg );
                        continue;
 
                // End of R: / T: lines
                }else{
                        end =1;
                }
        }

        // Move pointer back to start of last line
        fseek( fmsg, msg_pos, SEEK_SET );
}
 
// =========================================================================
 
void Start_Msg(void)
{
        if( strlen(from_bbs) >= 6 ) {
                fprintf( fmail, "#\nSP %s @ %s < %s\n", from_call, from_bbs, bbs_call );
        }else{
                fprintf( fmail, "#\nSP %s < %s\n", from_call, bbs_call );
        }
 
        fprintf( fmail, "Re: %s\n\n\n", subject );
}


// =========================================================================

void End_Msg(void)
{
	fprintf( fmail, "\n TTUPD V" Version " by G0LGS\n");
        fprintf( fmail, "/EX\n" );
}
 
// =========================================================================

void Process_Mail(void)
{
	int update = 0;
	int request = 0;
	char page[20];
	char *p;

	while( !feof( fmsg ) && fgets( buffer, sizeof(buffer), fmsg ) ) {

		p = buffer;

		// Allow forwarded messages
		while( p && p[0] == '>' ) {
			p++;
			if( p && p[0] == ' ' )
				p++;
		}

		if( strncasecmp( p, "PAGE_START", 10 ) == 0 ) {

			p+=10;
			if( sscanf( p, "%s[^ \r\n]", page ) == 1 ) {

				if( Do_update( page ) == 0 )
					update++;
			}

		} else if( strncasecmp( p, "REQUEST", 7 ) == 0 ) {

			p+=8;
			if( sscanf( p, "%s[^ \r\n]", page ) == 1 ) {

				if( Do_request( page ) == 0 )
					request++;
			}
		}
	}

	if( ! update && ! request ){
		fprintf( fmail, "\nNothing to do\n\n" );
	}

	if( update ) {
		fprintf( fmail, "\n%d Pages updated\n", update );
	}

	if( request ){
		fprintf( fmail, "\n%d Pages sent\n", request );
	}

        fclose(fmsg);
 
        if ( (fmsg=fopen( infofile, "r") ) != NULL) {
 
                while( ! feof(fmsg) && fgets( buffer, sizeof(buffer), fmsg ) ) {
                        show_line( fmail, buffer, 0 );
 
                }
                fclose(fmsg);
        }
}

// =========================================================================

int Do_update(char *page)
{
	int page_no;
	int end = 0;
	int lines = 0;
	char *p;
	char newfile[255];
	char oldfile[255];
	char ext[10];
	char tmp[80];

	// convert to page number
	page_no = atoi( page );

	// file extension
	if( ( p = strstr( page, "." ) ) != NULL ) {
		sscanf( p, "%s", ext );
        }else{
		strcpy( ext, ".tt" );
	}

	// Check page range and file type
	if( (page_no < 100) 	// Local pages
	||  (page_no > 999)	// Max page number
	||  ( ( strstr( page, ".tt" ) == NULL )
	&&  ( strstr( page, ".TT" ) == NULL )
	&&  ( strstr( page, ".htm" ) == NULL ) ) ) {

		fprintf( fmail, "TTUPD: Invalid page name '%s'\n", page );
		sprintf( tmp, "Invalid page name '%s' from %s", page, from_call );
		Log( tmp );
		return(1);
	}

	sprintf( oldfile, "%s/%03d%s", ttext_dir, page_no, ext );
	sprintf( newfile, "%s/%03d%s.new", ttext_dir, page_no, ext );

	if( (fpage = fopen( newfile, "w" ) ) == NULL ){

		fprintf( fmail, "TTUPD: Unable to create new page '%s'\n", page );
		sprintf( tmp, "Unable to create new page '%s' for %s", page, from_call );
		Log( tmp );
		return(1);
	}

	while( ! end && !feof( fmsg ) && fgets( buffer, sizeof(buffer), fmsg ) ){

		p = buffer;

		// Allow forwarded messages
		while( p && p[0] == '>' ) {
			p++;
			if( p && p[0] == ' ' )
				p++;
		}

		// Look for end of page
		if( strncasecmp( p, "PAGE_END", 8 ) == 0 ) {	
			end++;

		} else {
			lines++;
			fwrite( p, strlen(p), 1, fpage );
		}

	} // while

	if( lines ) {

		if( access( oldfile, F_OK ) != 0 ) {

			if( rename( newfile, oldfile ) == 0 ) {
				fprintf( fmail, "\tNew page '%03d%s' created\n", page_no, ext );
				sprintf( tmp, "Created new page ''%03d%s' for %s", page_no, ext, from_call );
				Log( tmp );
				return(0);

			} else {
				fprintf( fmail, "\tUnable to create new page '%03d%s'\n", page_no, ext );
				sprintf( tmp, "Unable to create new page '%03d%s' for %s", page_no, ext, from_call );
				Log( tmp );
				return(1);

			}

		} else if( access( oldfile, W_OK ) == 0 ) {

			if( unlink( oldfile ) != 0 ) {
				fprintf( fmail, "\tUnable to remove old page '%03d%s'\n", page_no, ext );
				sprintf( tmp, "Unable to remove old page '%03d%s' for %s", page_no, ext, from_call);
				Log( tmp );
				return(1);
			}

			if( rename( newfile, oldfile ) == 0 ) {
				fprintf( fmail, "\tPage '%03d%s' updated\n", page_no, ext );
				sprintf( tmp, "Page '%03d%s' updated for %s", page_no, ext, from_call);
				Log( tmp );
				return(0);

			} else {
				fprintf( fmail, "\tUnable to update '%03d%s'\n", page_no, ext );
				sprintf( tmp, "Unable to update '%03d%s' for %s", page_no, ext, from_call);
				Log( tmp );
				return(1);
			}

		} else {

			fprintf( fmail, "Unable to replace '%s'\n", oldfile );
			sprintf( tmp, "Unable to replace '%s' for %s", oldfile, from_call );
			Log( tmp );
			return(1);
		}

	}

	return(1);
}

// =========================================================================

int Do_request(char *page )
{
	char file[255];
	FILE *fpage;
	int page_no;
	char ext[10];
	char *p;
	char tmp[80];

	// convert to page number
	page_no = atoi( page );

	// file extension
	if( ( p = strstr( page, "." ) ) != NULL ) {
		sscanf( p, "%s", ext );
        }else{
		strcpy( ext, ".tt" );
	}

	// Check page range and file type
	if( (page_no < 100) 	// Local pages
	||  (page_no > 999)	// Max page number
	||  ( ( strstr( page, ".tt" ) == NULL )
	&&  ( strstr( page, ".TT" ) == NULL )
	&&  ( strstr( page, ".htm" ) == NULL ) ) ) {

		fprintf( fmail, "TTUPD: Invalid page name '%s'\n", page );
		sprintf( tmp, "%s Requested an Invalid page '%s'", from_call, page );
		Log( tmp );
		return(1);
	}

	if( strlen( page ) > 0 ) {

		sprintf( file, "%s/%s", ttext_dir, page );

		if( ( fpage = fopen( file, "r" ) ) != NULL ) {

			fprintf( fmail, "PAGE_START %s\n", page );

			while( !feof(fpage) && fgets( buffer, sizeof(buffer), fpage) ) {

				fprintf( fmail, "%s", buffer );

			}

			fclose(fpage);

			fprintf( fmail, "PAGE_END\n" );

			return(0);

		} else {
			fprintf( fmail, "\nNo such page (%s)\n\n", page );
			sprintf( tmp, "%s Requested an non-existant page '%s'", from_call, page );
			Log( tmp );
			return(1);
		}

	} else {
		fprintf( fmail, "\nNo such page (%s)\n\n", page );
		sprintf( tmp, "%s Requested an non-existant page '%s'", from_call, page );
		Log( tmp );
		return(1);
	}

	return(1);
}
