/* ttuilts.c by G0LGS July 2001 */

#include "config.h"

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include <unistd.h>

int get_config (void);
void store_upd (char *p);
void store_user (char *p);
void store_web (char *p);
void translate_user (char *from, char *to);
int show_page(FILE *f, char *page_no);
int show_htmpage(FILE *f, char *page_no);
void show_prompt(FILE *fout);
void show_line(FILE *fout, char *line, char *page_no);
void show_file(FILE *fout, char *filenm, char *page_no);
void show_vers (void);
int  user_allowed (void);
int ReadInit (void);
void Log(char *logtext);

int page_nbr = 000, level_nbr ;

#define LEN 25
#define USER 199
#define UPDATE 9
#define WEB 199

char conf_dir [255] = CFGDIR;
char ttext_dir [255] = TTDIR;
char infofile [255] ="";
char mailin [255] ="";
char data_path [255] ="";
char logfile [255] = LOGFILE;
char logtime [255] = LOGTIME;

char prompt [255] = PROMPT ;
char pg_date [12], pg_time [6];

char bbs_call [12] ="";
char bbs_ssid [3] ="";
char bbs_zip  [10] ="";
char sys_name [12] ="";
char sys_call [12] ="";
char city [30] = "";
char qra [16] = "";
int lines = 0;

extern char from_call[];
extern char from_bbs[];

extern char app_name[];

// variables that the config file can overwrite
char first_page[LEN] = "100", help_page[LEN] = "000";
char no_page[LEN] = "nopage", index_page[LEN] = "100";
int maxpages=10, linemax=30;

// user-defined names
char user [USER] [LEN];
char upage [USER] [LEN];

// who can upload updates (Max 10 of 6 Chars each)
char update [UPDATE] [7];

// ranges of page numbers we allow to be viewed from the internet
int  webl [WEB], web_min=999999;
int  webu [WEB], web_max = -1;

int readcfg = 0;

char u_name[13] ="";
char u_city[31] ="";
char u_home[41] ="";
char u_qra[7] ="";
char u_zip[9] ="";

//=========================================================================

int get_config(void)
{
	FILE *fc;
	char buffer [255];
	int i;
	int end = 0;
	int len;
	char *scan;
	char *ptr;
	char key[20];
	char conf_fil[255];

   	for (i=0 ; i <= USER ;i++) {
		user [i] [0] = 0;
		upage [i] [0] = 0;
	} 

   	for (i=0 ; i <= WEB ;i++) {
		webl [i] = 999999;
		webu [i] = -1;
	} 

	// put in our default INDEX entry
	strcpy( upage[0], index_page );
	strcpy( user[0], "INDEX" );

	sprintf( conf_fil, "%s/%s", conf_dir, "ttext.cfg" );

	if ( ( fc = fopen( conf_fil, "r" ) ) != NULL ) {

		while( ! end && fgets( buffer, sizeof(buffer), fc) ){

			scan = buffer;

			// Eat Spaces
			while (isspace(*scan))
				++scan;

			// Comments & Blanks ignored
			if (*scan == '#' || *scan == '\0' )
				continue;

			// remove ending '\n'
			len = strlen(scan);
			if( len && (scan[len-1] == '\n'))
				scan[len-1] = '\0';

			// keyword
			i=0;
			ptr = key;
			while( isgraph(*scan)) {
				*ptr++ = *scan;
				++scan;
				if(*scan == '=')
					break;         
			}
			*ptr = '\0';

			// find the '='
			scan = strchr(scan, '=');

			// copy value
			if(scan) {
				++scan;
				while( isspace(*scan))
					++scan;

				// if 1st char is '"' then string
				if( *scan == '"' ){
					++scan;
					ptr = strrchr(scan,'"');
					if(ptr)
						*ptr = '\0';
				}

				if( strcasecmp( key, "prompt" ) == 0 ) {
					strcpy( prompt, scan );

				}else if( strcasecmp( key, "index" ) == 0 ) {
					strcpy( index_page, scan );

				}else if( strcasecmp( key, "firstpage" ) == 0 ) {
					strcpy( first_page, scan );

				}else if( strcasecmp( key, "nopage" ) == 0 ) {
					strcpy( no_page, scan );

				}else if( strcasecmp( key, "user" ) == 0 ) {
					store_user( scan );

				}else if( strcasecmp( key, "webok" ) == 0 ) {
					store_web( scan );

				}else if( strcasecmp( key, "updates" ) == 0 ) {
					store_upd( scan );

				}else if( strcasecmp( key, "info" ) == 0 ) {
					strcpy( infofile, scan );

				}else if( strcasecmp( key, "maxpages" ) == 0 ) {
					maxpages = atoi( scan );

				}else if( strcasecmp( key, "linemax" ) == 0 ) {
					linemax = atoi( scan );

				}else if( strcasecmp( key, "ttdir" ) == 0 ) {
					strcpy( ttext_dir, scan );

				}else if( strcasecmp( key, "logfile" ) == 0 ) {
					strcpy( logfile, scan );

				}else if( strcasecmp( key, "logtime" ) == 0 ) {
					strcpy( logtime, scan );

				}

			}
		}

		fclose(fc);

	}else{
		return(1);		
	}

	return(0);
}

//==========================================================================

void store_upd (char *p)
{
	char *tok1;
	int i = 0;

	tok1 = strtok( p, ", \r\n" );

	while( (tok1 != NULL) && (i <= UPDATE) ) {   

		strncpy( update[i], tok1, sizeof(update[i])-1 );
		tok1 = strtok( NULL, ", \r\n" );

		i++;
	}
}

//============================================================================

void store_user (char *p)
{
	char *tok1, *tok2;
	int i = 0;

	tok1 = strtok( p, ", \r\n" );

	while( (tok1 != NULL) && (i <= USER) ) {   

		tok2 = strtok( NULL, ", \r\n" );
		strncpy( user[i], tok1, sizeof(user[i])-1 );
		strncpy( upage[i], tok2, sizeof(upage[i])-1 );
		tok1 = strtok( NULL, ", \r\n" );

		i++;
	}
}

//============================================================================

void store_web (char *p)
{
	/* pages that can be viewed from the internet are stored as:
		WEBOK=lower,upper[,lower,upper[,lower,upper[........]]]

	e.g	WEBOK=100,100,200,500,600,600     will allow pages 100, 200-500 and 600  
	(lower must equal upper for a single page)*/

	char *tok1, *tok2;
	int i = 1;// we put our own INDEX entry in later

	tok1 = strtok( p, ", \r\n" );

	while( (tok1 != NULL) && (i <= WEB) ) {   

		tok2 = strtok( NULL, ", \r\n" );
		webl [i] = atoi(tok1);

		if (webl [i] < web_min)
			web_min = webl [i];

		webu [i] = atoi(tok2);

		if (webu [i] > web_max)
			web_max = webu [i];

		tok1 = strtok( NULL, ", \r\n" );

		i++;
	}
}

//============================================================================

void translate_user (char *from, char *to )
{
	int j;
	char temp [LEN + 4], page_adj [LEN + 2];
	char *pt;

	to [0] = 0 ;	//in case of garbage
 
	strncpy( temp, from, LEN ); 
	temp [LEN] = 0;
	strcat( temp, " " );

	if ( atoi(temp) > 0) {			// already numeric?
		sprintf( to, "%03i", atoi(temp) );
		return;
	}
 
	if ( (pt = strtok( temp, " \r\n\t;#?" ) ) == NULL) return;

	strcpy( page_adj, pt );

	for( j=0; j <= USER; j++ ) {

		if (strcasecmp( user[j], page_adj ) == 0 ) {
			sprintf( to, "%03i", atoi(upage [j]) ); 
			 break;
		}
	}

	return;
}

//==========================================================================

int show_page(FILE *fout, char *page_no)
{
	// this routine exhibits a selected text page

	FILE *fp;
	char  temp [255];

	if (strlen(page_no) == 0 )
		return (1);   // ignore empty lines!

	sprintf( temp, "%s/%s.tt", ttext_dir, page_no );

	if ( (fp = fopen( temp, "r" ) ) == NULL ) {  // try for upper case TT name

		sprintf( temp, "%s/%s.TT", ttext_dir, page_no );


		if ( (fp = fopen( temp,"r" ) ) == NULL ) {

			if( strcmp( page_no, no_page ) == 0 ) {

				show_line( fout, NOPAGE, page_no );
			}

			return (-1);
		}
	}

	while ( ! feof(fp) && fgets( temp, sizeof(temp), fp ) ) {

		show_line( fout, temp, page_no);
		lines++;

	} // while

	fclose(fp);

	return(0);
}

//=======================================================================

int show_htmpage(FILE *fout, char *page_no)
{
	// this routine exhibits a selected html or text page

	FILE *fp;
	char  temp [255];
	int htm = 1;

	if (strlen(page_no) == 0 )
		return (1);   // ignore empty lines!

	// Try .htm first
	sprintf( temp, "%s/%s.htm", ttext_dir, page_no );

	if ( (fp = fopen( temp, "r" ) ) == NULL ) {

		htm=0;

		// Try .tt
		sprintf( temp, "%s/%s.tt", ttext_dir, page_no );

		if ( (fp = fopen( temp, "r" ) ) == NULL ) {

			// Try .TT
			sprintf( temp, "%s/%s.TT", ttext_dir, page_no );

			if ( (fp = fopen( temp,"r" ) ) == NULL ) {

				return (-1);
			}
		}
	}

	if( ! htm ){
		printf("<PRE>\n");
	}


	while ( ! feof(fp) && fgets( temp, sizeof(temp), fp ) ) {

		show_line(fout, temp, page_no);
		lines++;

	} // while

	if( ! htm ){
		printf("</PRE>\n");
	}

	fclose(fp);

	return(0);
}

//=======================================================================

void show_line( FILE *fout, char *line, char *page_no )
{
	// print a line, translating $variables and special chars as we go

	unsigned char *p, *p1;
	char filenm [250];

	p = (unsigned char *) line;

	while (*p) {

		switch (*p) {

			case 176:
			case 177:
				fprintf( fout, " " );
				p++;
				break;

			case 195:
			case 196:
			case 205:
			case 208:
			case 209:
			case 218:
				fprintf( fout, "=" );
				p++;
				break;

			case '%':

				switch (*(p+1)) {

					case 'A':	// App Name
						fprintf( fout, "%-9s", app_name );
						p+=2;
						break;

					case 'O':	// Sysop Call
						fprintf( fout, sys_call );
						p+=2;
						break;

					case 'V':	// TText Version
						fprintf( fout, "V%s", Version );
						p+=2;
						break;

					case '%':	// escape seq is %%
						fprintf( fout, "%%" );
						p+=2;
						break;

					default:	// Treat as normal
						fprintf( fout, "%c", *p );
						p++;
						break;

				} // switch p+1 when p='%'

			case '$':

				switch (*(p+1)) {

					case 'b':	// User Zip
						fprintf( fout, u_zip );
						p+=2;
						break;

					case 'c':	// BBS City
						fprintf( fout, city );
						p+=2;
						break;

					case 'd':	// DD-Jan
						fprintf( fout, pg_date );
						p+=2;
						break;

					case 'h':	// HOME_BBS
						fprintf( fout, u_home );
						p+=2;
						break;

					case 'o':	// BBS SSID
						fprintf( fout, bbs_ssid );
						p+=2;
						break;

					case 'u':	// Remote BBS / IP
						fprintf( fout, from_bbs );
						p+=2;
						break; 

					case 'z':	// BBS ZIP
						fprintf( fout, bbs_zip );
						p+=2;
						break;

					case 'A':	// App Name
						fprintf( fout, "%9s", app_name );
						p+=2;
						break;

					case 'H':	// HH:MM
						fprintf( fout, pg_time );
						p+=2;
						break;

					case 'I':	// Users Name
						fprintf( fout, u_name );
						p+=2;
						break;

					case 'O':	// BBS Call
						fprintf( fout, bbs_call );
						p+=2;
						break;

					case 'U':	// User Call or Hostname
						fprintf( fout, from_call );
						p+=2;
						break; 

					case 'V':	// Sysop Name
						fprintf( fout, sys_name );
						p+=2;
						break;

					case 'W':	// CR
						fprintf( fout, "\r\n" );
						p+=2;
						break;

					case '?':	// BBS Qra
						fprintf( fout, qra );
						p+=2;
						break;

					case '@':	// Page Number
						fprintf( fout, page_no );
						p+=2;
						break;

					case '$':	// escape seq is $$
						fprintf( fout, "$" );
						p+=2;
						break;

					case '=':	// level number
						fprintf( fout, "%d", level_nbr );
						p+=2;
						break;

					case '<':	// Insert File
						p+=2;
						if( *p == '"' ) {
							p++;
							p1 = strchr( p, '"' );
							if( p1 )
								*p1 = '\0';
							strcpy( filenm, p );
							p+=( strlen(filenm)+1 );
						}else{	
							strcpy( filenm, strtok( p," :\r\n\t") );
							p+=( strlen(filenm) );
						}
						show_file( fout, filenm, page_no );

					default:	// Treat as normal
						fprintf( fout, "%c", *p );
						p++;
						break;

				} // switch p+1 when p='$'

			default:
				fprintf( fout, "%c", *p );
				p++;
				break;

		} //switch *p        

	} //while

}

//================================================================

void show_file( FILE *fout, char *filenm, char *page_no )

{
	FILE *ff;
	char buffer [255];
	char newfile[255];

	// avoid '../' & '..\' !
	if( strstr( filenm, "../" ) || strstr( filenm, "..\\" ) ) {
		return;
	}

	sprintf( newfile, "%s/%s", ttext_dir, filenm );

	if ( (ff = fopen( newfile, "r" ) ) == NULL) {
		return;

	}else {
		while( !feof(ff) && fgets( buffer, sizeof(buffer), ff ) ) {

			show_line( fout, buffer, page_no );
			lines++;
		}
	}

	fclose(ff);
}    

//================================================================    

int  user_allowed (void)
{
	int i = 0;
	int ok = 1;

        // Check users
        for( i=0; i <= UPDATE; i++ ){
                if( strcasecmp( update[i], from_call ) == 0 ) {
                        ok = 0;
                }
        }
 
	return(ok);	
}

//================================================================    

void show_prompt(FILE *fout)
{
	show_line( fout, prompt, "0" );

}

//=======================================================================

void show_vers(void)
{
	printf( "********************************************\r\n" );
	printf( "*** FBBtext V" Version " " Vdate " by G0LGS  ***\r\n" );
	printf( "********************************************\r\n\r\n" );
}

//==========================================================================

int ReadInit(void)
{
	FILE *init_ptr;
	int len, i;
	char buffer[256];
	char *scan;
	char *ptr;
	char key[20];
	char pathname[256];
	struct tm *loctime;
	time_t now;


	if( (ptr = getenv("FBBCONF")) == NULL ){
		strcpy( pathname, FBBCONF);
	}else{
		strcpy( pathname, ptr);
	}

	if( ( init_ptr = fopen (pathname, "r") ) != NULL ) {

		while( ! feof(init_ptr) && fgets(buffer, sizeof(buffer), init_ptr) ) {

			scan = buffer;

			/* Eat Spaces */
			while (isspace(*scan))
				++scan;

			/* Comments & Blanks ignored */
			if (*scan == '#' || *scan == '\0' )
				continue;

			/* remove ending \n */
			len = strlen(scan);
			if( len && (scan[len-1] == '\n'))
				scan[len-1] = '\0';

			/* keyword */
			i=0;
			ptr = key;
			while( isgraph(*scan)) {
				if( i++ < 4 ) {
					*ptr++ = *scan;
				}
				++scan;
				if(*scan == '=')
					break;         
			}
			*ptr = '\0';

			/* find the '=' */
			scan = strchr(scan, '=');

			/* copy value */
			if(scan) {
				++scan;
				while( isspace(*scan))
					++scan;

				/* if 1st char is '"' then string */
				if( *scan == '"' ){
					++scan;
					ptr = strrchr(scan,'"');
					if(ptr)
						*ptr = '\0';
				}

				if( strcmp( key, "call" ) == 0 ) {
					*strstr( scan, "." ) = '\0';
					strcpy( bbs_call, scan );

				}else if( strcmp( key, "ssid" ) == 0 ) {
					strcpy( bbs_ssid, scan );

				}else if( strcmp( key, "conf" ) == 0 ) {
					strcpy( conf_dir, scan );

				}else if( strcmp( key, "name" ) == 0 ) {
					strcpy( sys_name, scan );

				}else if( strcmp( key, "syso" ) == 0 ) {
					strcpy( sys_call, scan );

				}else if( strcmp( key, "impo" ) == 0 ) {
					strcpy( mailin, scan );

				}else if( strcmp( key, "city" ) == 0 ) {
					strcpy( city, scan );

				}else if( strcmp( key, "qral" ) == 0 ) {
					strcpy( qra, scan );

				}else if( strcmp( key, "zipc" ) == 0 ) {
					strcpy( bbs_zip, scan );

				}else if( strcmp( key, "data" ) == 0 ) {
					strcpy( data_path, scan );

				}

			}
		}

		fclose(init_ptr);
  
	}else{
		fprintf( stdout, "Unable to open '%s'\n", pathname );
		return 1;
	}


	now = time(0);
	loctime = localtime(&now);

	strftime( pg_date, sizeof(pg_date), "%d-%m-%Y", loctime );
	strftime( pg_time, sizeof(pg_time), "%H:%M", loctime );


	readcfg++;
	return 0;
}

//==========================================================================

void Log(char *logtext)
{
	struct tm *loctime;
	time_t now;
	char log_date[40];
	FILE *lg;
	char week[3];
	char logname[255];

	if( strlen( logfile ) > 1 ) {

		now = time(0);
		loctime = localtime(&now);

		// Full Logfile name
		strftime( week, sizeof(week), "%U", loctime );
		sprintf( logname, "%s.%s", logfile, week );

		strftime( log_date, sizeof(log_date), logtime, loctime );

		if( access( logname, F_OK ) != 0 ){
			if( (lg = fopen( logname, "at" ) ) != NULL ) {
				fprintf( lg, "%s %s[%i]: %s\n", log_date, app_name, getpid(), "Log Created" );
				fclose( lg );
			}
		}

		if( (lg = fopen( logname, "at" ) ) != NULL ) {
			fprintf( lg, "%s %s[%i]: %s\n", log_date, app_name, getpid(), logtext );
			fclose( lg );
		}

	}
}
