/* webtt.c by G0LGS July 2001 */

#include "config.h"

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <unistd.h>

#define WEB 199

// from ttutils
int get_config (void);
void get_page(void);
void translate_user (char *from, char *to);
int show_htmpage(FILE *f, char *page_no);
int ReadInit(void);

// local
int valid_for_web(int pg);

extern int page_nbr , level_nbr ;
extern char index_page[];

extern char bbs_call[];

char from_call[12]="CGI-BIN";
char from_bbs[64] ="Browser";
char app_name[6] ="WEBTT";

// variables that the config file can overwrite
extern int max, linemax;
extern char mailin [] ;
extern char no_page[];

// ranges of page numbers we allow to be viewed from the internet
extern int  webl [], web_min;
extern int  webu [], web_max;

char *qsptr, *premote;

int main(int argc, char **argv)
{

	printf("Content-Type: text/html\n\n");

	get_config();
     
	if ( (qsptr = getenv("QUERY_STRING")) == NULL){

		if (argc > 1) {

			qsptr = argv [1];  // mainly for testing

		} else {
			qsptr = no_page;
		}
	}

	if ( (premote = getenv("REMOTE_HOST")) != NULL){
		strncpy( from_call, premote, strlen(premote) );
	}

	if ( (premote = getenv("REMOTE_ADDR")) != NULL){
		strncpy( from_bbs, premote, strlen(premote) );
	}

	ReadInit();

	get_page();

	return (0);
}        

//==================================================================

void get_page(void)
{
	char tmp [50], tmp2 [50];

	translate_user( qsptr, tmp );

	printf("<HTML><HEAD><TITLE>Page %s at %s</TITLE></HEAD>\n",tmp,bbs_call);
	printf("<SCRIPT LANGUAGE=\"Javascript\">\n");
	printf("var newref=\"webtt?\";");
	printf("</SCRIPT><FORM>");
	printf("<BODY>\n");

	if( valid_for_web(atoi(tmp)) ) {

		if( show_htmpage( stdout, tmp ) !=0 ) {

			if( strlen(tmp) < 3 )	{	// try leading zeros ?
				sprintf( tmp2, "00%s", tmp );

				if( show_htmpage( stdout, tmp2 + strlen(tmp2)-3 ) !=0 ) {

					show_htmpage( stdout, no_page );
				}

			} else { 

				show_htmpage( stdout, no_page );
			}
		}

	} else {

		show_htmpage( stdout, no_page );
	}

	printf("<CENTER>");

	if( web_min > atoi(index_page) ) {

		printf("<A HREF=\"webtt?%03i\">Top</A>\n",web_min);

	} else {

		printf("<A HREF=\"webtt?%03i\">Index</A>\n",atoi(index_page));
	}

	printf("&nbsp&nbsp&nbsp");
	printf("<A HREF=\"webtt?%03i\">End</A>\n",web_max);
	printf("&nbsp&nbsp&nbsp");
	printf("<INPUT TYPE=\"text\" VALUE=\"%03i\" NAME=\"pgno\" SIZE=5>\n", atoi(tmp));
	printf("<INPUT TYPE=\"button\" ");
	printf("   ONCLICK=\"location.href=newref+pgno.value\" ");
	printf("   VALUE=\"GoTo Page\">\n");
	printf("</CENTER></FORM>"); 
	printf("</BODY></HTML>");
}

//====================================================================

int valid_for_web(int pg)
{

	// the list of pages valid for web gets stored in an array from the config file

	int k;

	for (k=0; k <= WEB ; k++)  {
		if ( (pg >= webl [k]) && ( pg <= webu [k]) ) {
			return (1);
		}
	}

	return (0);

}
